# Copyright (C) 2004 by Dr. Dieter Maurer, Eichendorffstr. 23, D-66386 St. Ingbert, Germany
# see "LICENSE.txt" for details
#	$Id: __init__.py,v 1.4 2004/06/13 20:52:50 dieter Exp $
'''Controled Cache SQL Method Product'''
import SQL, Shared.DC.ZRDB.Search


# This is the new way to initialize products.  It is hoped
# that this more direct mechanism will be more understandable.
def initialize(context):

    context.registerClass(
        SQL.SQL,
        permission='Add Database Methods',
        constructors=(SQL.manage_addCCSQLMethodForm, SQL.manage_addCCSQLMethod),
        icon='sqlmethod.gif',
        )


methods={
    # We still need this one, at least for now, for both editing and
    # adding.  Ugh.
    'SQLConnectionIDs': SQL.SQLConnectionIDs,

    # Oh please!
    'ZQueryIds':             Shared.DC.ZRDB.Search.ZQueryIds,
    }

__ac_permissions__=(
    # Ugh.  We should get rid of this, but we'll have to revisit connections
    ('Open/Close Database Connections',   ()),
    )

try:
    from Products.CMFCore.FSZSQLMethod import FSZSQLMethod
    from Products.CMFCore.DirectoryView import registerFileExtension, registerMetaType
    
    class FSCCSQLMethod(SQL.SQL, FSZSQLMethod):
        """File system based CC SQL Method."""
        meta_type = "Filesystem CC SQL Method"

        manage_options = FSZSQLMethod.manage_options

        __init__ = FSZSQLMethod.__init__
        __of__ = FSZSQLMethod.__of__

        def _createZODBClone(self):
            """Create a ZODB (editable) equivalent of this object."""
            # I guess it's bad to 'reach inside' ourselves like this,
            # but Z SQL Methods don't have accessor methdods ;-)
            s = SQL.SQL(self.id,
                    self.title,
                    self.connection_id,
                    self.arguments_src,
                    self.src)
            s.manage_advanced(self.max_rows_,
                              self.max_cache_,
                              self.cache_time_,
                              '',
                              '')
            return s

    registerFileExtension('ccsql', FSCCSQLMethod)
    registerMetaType('CC SQL Method', FSCCSQLMethod)
 
except ImportError: pass

